#
# spec file for package openwbem (Version 3.1.1)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org
#

# norootforbuild
# neededforbuild  gpp libgpp openslp openslp-devel openssl openssl-devel pam-devel

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libnscd libselinux libstdc++ libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gcc-c++ gdbm gettext libstdc++-devel libtool openslp openslp-devel openssl-devel pam-devel perl rpm

Name:         openwbem
%define prefix /usr
%define localstatedir /var/lib
%define startnum 36
%define killnum 64
%define daemonname owcimomd
%define owversion 3.1.1
Version:      3.1.1
Release:      2.1
Group:        System/Management
Summary:      Web Based Enterprise Management (WBEM) Implementation
License:      BSD
URL:          http://openwbem.sourceforge.net/
Source0:      %{name}-%{version}.tar.bz2
Source1:      novell-openwbem-root-acl.mof
Source2:      loadmof.sh
Source3:      rmmof.sh
Source4:      openwbem-owcimomd.init
Source5:      openwbem-etc_pam.d_openwbem
Source6:      http://www.dmtf.org/standards/cim/cim_schema_v2101/cimv2101Experimental-MOFs.zip
Source7:      %{name}-3.1.0.tar.bz2
Patch2:       perl_path.patch
Patch7:       m4.dif
Patch8:       openwbem-3.1.0-repository_dump.patch
Patch9:       openwbem-3.1.0-friend-injection.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
Provides:     cim-server
Conflicts:    pegasus-wbem
PreReq:       sed, coreutils, grep, /bin/hostname, %insserv_prereq %fillup_prereq
%debug_package
%package devel
Group           : Programming/Library
Summary         : Headers files for OpenWBEM
Requires	: openwbem = %{version}-%{release}

%description
OpenWBEM is a set of software components that help facilitate the
deployment of the DMTF's (Distributed Management Task Force) CIM/WBEM
technologies. If you are not familiar with the DMTF and it's
technologies, you might want to visit their web site at
http://www.dmtf.org.



Authors:
--------
    Jon Carey
    Dan Nuffer 
    Bart Whiteley 
    Markus Mueller
    Matthias Hoelzer-Kluepfel
    Brian Nesse


%description devel
OpenWBEM is a set of software components that help facilitate the
deployment of the DMTF's (Distributed Management Task Force) CIM/WBEM
technologies. If you are not familiar with the DMTF and it's
technologies, you might want to visit their web site at
http://www.dmtf.org.



Authors:
--------
    Bart Whiteley 
    Calvin Gaisford
    Dan Nuffer 
    Shane Smit 
    Stan Covington 

%prep
# unpack version 3.1.0 to get repository dump capable of dumping the 
# old repository
%setup -T -b 7 -n %{name}-3.1.0
%patch8 -p0 -b .orig
%patch9 -p0 -b .orig
%setup  %{name}-%{version}
%patch2 -b .perl_path
%patch7 -p0 -b .m4

%build
# Fix the config file
sed  \
  -e "s!^owcimomd.allowed_users =.*!owcimomd.allowed_users = \*!g" \
  -e "s!^;owcimomd.ACL_superuser =.*!owcimomd.ACL_superuser = root!g" \
  -e "s!^http_server.http_port = 5988!http_server.http_port = -1!g" \
  -e "s!^http_server.allow_local_authentication = false!http_server.allow_local_authentication = true!g" \
  -e "s!^cppprovifc.prov_location = @libdir@/openwbem/c++providers!cppprovifc.prov_location = @libdir@/openwbem/c++providers:/opt/novell/lib/openwbem/c++providers!g" \
  -e "s!^cmpiprovifc.prov_location = @libdir@/openwbem/cmpiproviders!cmpiprovifc.prov_location = @libdir@/cmpi!g" \
  < etc/openwbem.conf.sh > etc/openwbem.conf.sh.new
mv etc/openwbem.conf.sh.new etc/openwbem.conf.sh 
#autoreconf --force --install
CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=%{prefix} \
	--sysconfdir=/etc \
	--libdir=%_libdir \
	--localstatedir=%{localstatedir} \
        --enable-perl-providerifc \
	--libexecdir=%{prefix}/%_lib/openwbem/bin \
	--mandir=%_mandir \
	--enable-threads-run-as-user
make %{?jobs:-j%jobs}
# Now work on old repository dump
OLDDIR=`pwd`
cd ../openwbem-3.1.0
# regen Makefile.in cuz a Makefile.am was patched
autoreconf --force --install
CFLAGS="$RPM_OPT_FLAGS" ./configure \
	--prefix=%{prefix} \
	--sysconfdir=/etc \
	--libdir=%_libdir \
	--localstatedir=%{localstatedir} \
        --enable-perl-providerifc \
	--libexecdir=%{prefix}/%_lib/openwbem/bin \
	--mandir=%_mandir \
	--enable-threads-run-as-user
cd db
make %{?jobs:-j%jobs}
cd ../src/cim
make %{?jobs:-j%jobs}
cd ../ifcs
make %{?jobs:-j%jobs}
cd ../common
make %{?jobs:-j%jobs}
cd ../repositories/hdb
make %{?jobs:-j%jobs}
cd ../../tools
make %{?jobs:-j%jobs} owrepositorydump
cd $OLDDIR

%install
%{__rm} -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
install -d $RPM_BUILD_ROOT/var/adm/fillup-templates
install -m 644 etc/sysconfig/daemons/owcimomd $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.owcimomd
install -d $RPM_BUILD_ROOT/etc/init.d
install -d $RPM_BUILD_ROOT/usr/sbin
install -d $RPM_BUILD_ROOT/usr/bin
ln -sf ../../etc/init.d/owcimomd $RPM_BUILD_ROOT/usr/sbin/rcowcimomd
install -d $RPM_BUILD_ROOT/etc/pam.d
install -d $RPM_BUILD_ROOT%_libdir/openwbem/cmpiproviders
install -m 644 etc/pam.d/openwbem $RPM_BUILD_ROOT/etc/pam.d
install -d $RPM_BUILD_ROOT/%{prefix}/%_lib/openwbem/c++providers
install -d $RPM_BUILD_ROOT/%{localstatedir}/openwbem
install -m 755 %{S:2} $RPM_BUILD_ROOT/usr/bin
install -m 755 %{S:3} $RPM_BUILD_ROOT/usr/bin
install -m 755 %{S:4} $RPM_BUILD_ROOT/etc/init.d/owcimomd
install -m 644 %{S:5} $RPM_BUILD_ROOT/etc/pam.d/openwbem
# Load the schema.
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$RPM_BUILD_ROOT/%{prefix}/%_lib
export LD_LIBRARY_PATH
MOFPATH=$RPM_BUILD_ROOT/%{prefix}/share/%{name}/mof
CIM210PATH=$MOFPATH/cimv2.10-exp
install -d $CIM210PATH
unzip -d $CIM210PATH %{S:6}
chmod -R og-w $CIM210PATH
perl -p -i -e 's/\\/\//g' $CIM210PATH/cimv210.mof
install -d $MOFPATH/openwbem
install -m 644 mof/*.mof $MOFPATH/openwbem
install -m 644 %{S:1} $MOFPATH/openwbem
#hack until OW is fixed to not care about empty dirs. 
install -d $RPM_BUILD_ROOT/opt/novell/lib/openwbem/c++providers
# install old repository dump
install ../openwbem-3.1.0/src/tools/owrepositorydump \
	$RPM_BUILD_ROOT/%_libdir/openwbem/owrepositorydump-3.1.0
# touch them here so we can %ghost them in %files. 
touch $RPM_BUILD_ROOT/%{localstatedir}/openwbem/{classassociation,instances,instassociation,namespaces,schema}.{dat,ndx,lock}
# END OF INSTALL
%perl_process_packlist

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
DUMPUTIL=%{prefix}/sbin/owrepositorydump
REPODIR=%{localstatedir}/openwbem
if [ "x$1" == "x2" ]; then
  if [ -x $DUMPUTIL ]; then
    if [ ! -d $REPODIR/dump ]; then
      mkdir $REPODIR/dump
    fi
    DUMPFILE=$REPODIR/dump/repo.mof
    CIMOM_INIT=/etc/init.d/owcimomd
    if [ "$YAST_IS_RUNNING" != "instsys" ] ; then
      $CIMOM_INIT status
      if [ "x$?" = "x0"  ]; then
        $CIMOM_INIT stop
        touch $REPODIR/dump/restart
      fi
    fi
    $DUMPUTIL -d $REPODIR -o $DUMPFILE || rm -f $DUMPFILE
  fi
fi

%post
test -n "$MY_FIRST_ARG" || MY_FIRST_ARG=$1
%{fillup_and_insserv -y -n owcimomd owcimomd}
REPODIR=%{localstatedir}/openwbem
MOFDIR=%{prefix}/share/%{name}/mof
CIM210PATH=$MOFDIR/cimv2.10-exp
# install
if [ "x$MY_FIRST_ARG" == "x1" ]; then 
  %{prefix}/bin/owmofc -c -n root/cimv2 -d $REPODIR -s $MOFDIR \
      $CIM210PATH/qualifiers.mof \
      $MOFDIR/openwbem/OpenWBEM_Interop.mof > /dev/null 2>&1 || true
  %{prefix}/bin/owmofc -c -n root -d $REPODIR -s $MOFDIR \
      $CIM210PATH/qualifiers.mof \
      $MOFDIR/openwbem/OpenWBEM_Interop.mof  > /dev/null 2>&1 || true
  %{prefix}/bin/owmofc -c -n root/security -d $REPODIR -s $MOFDIR \
      $MOFDIR/openwbem/OpenWBEM_Acl1.0.mof \
      $MOFDIR/openwbem/novell-openwbem-root-acl.mof > /dev/null 2>&1 || true
# upgrade
elif [ "x$MY_FIRST_ARG" == "x2" ]; then 
  # in the case of upgrade, make sure novell provider dir is supported
  if ! grep -q "cppprovifc\.prov_location.*/opt/novell/lib/openwbem/c++providers.*" /etc/openwbem/openwbem.conf; then 
    sed -e 's!^\(cppprovifc\.prov_location.*\)!\1:/opt/novell/lib/openwbem/c++providers!' \
  	< /etc/openwbem/openwbem.conf > /etc/openwbem/openwbem.conf.tmp; 
    mv /etc/openwbem/openwbem.conf.tmp /etc/openwbem/openwbem.conf
  fi
  if ! grep -q "^http_server\.allow_local_authentication = true" /etc/openwbem/openwbem.conf; then 
    sed -e 's!.*http_server\.allow_local_authentication.*!http_server\.allow_local_authentication = true!' \
  	< /etc/openwbem/openwbem.conf > /etc/openwbem/openwbem.conf.tmp; 
    mv /etc/openwbem/openwbem.conf.tmp /etc/openwbem/openwbem.conf
  fi
  # handle upgrade of repository
  if [ -f $REPODIR/dump/restart ]; then
    CIMOM_RESTART=1
  fi
  DUMPFILE=$REPODIR/dump/repo.mof
  CIMOM_INIT=/etc/init.d/owcimomd
  OLDDUMP=%_libdir/openwbem/owrepositorydump-3.1.0
# If no dump file exists, we assume we're upgrading from version 3.1.0
  if [ ! -f $DUMPFILE ]; then
    if [ -x $OLDDUMP ]; then
      mkdir -p $REPODIR/dump
      if [ "$YAST_IS_RUNNING" != "instsys" ] ; then
        $CIMOM_INIT status
        if [ "x$?" = "x0" ]; then
          CIMOM_RESTART=1
        fi
      fi
      echo "dumping version 3.1.0 repository" 
      $CIMOM_INIT stop
      $OLDDUMP -d $REPODIR -o $DUMPFILE || rm -f $DUMPFILE
    fi
  fi
  if [ -f $DUMPFILE ]; then
    mkdir $REPODIR/backup
    cp $REPODIR/*.{dat,ndx,lock} $REPODIR/backup || true
    rm -f $REPODIR/*.{dat,ndx,lock}
    loadmof.sh -n root $DUMPFILE
    if [ "x$?" == "x0" ]; then
      rm -rf $REPODIR/backup
      rm -rf $REPODIR/dump
      
    else
      mv $REPODIR/backup/* $REPODIR
      rmdir $REPODIR/backup
    fi
  fi
  if [ "x$CIMOM_RESTART" = "x1" ]; then
    $CIMOM_INIT restart
  fi
fi

%postun
%{insserv_cleanup}

%files
%defattr(-,root,root)
%doc README TODO 
%doc AUTHORS COPYING ChangeLog LICENSE
%doc doc/*.HOWTO doc/*.html
%dir %{prefix}/%_lib/openwbem
%{prefix}/%_lib/openwbem/*
%dir %{prefix}/share/openwbem
%dir %{localstatedir}/openwbem
%ghost %{localstatedir}/openwbem/*
%dir /etc/openwbem
%config(noreplace) /etc/openwbem/*
%config /etc/pam.d/openwbem
%attr(0755,root,root) /etc/init.d/%{daemonname}
#/usr/lib/perl5/vendor_perl/5.8.1/i586-linux-thread-multi/perlNPI.pm
%{perl_vendorarch}/auto/perlNPI
%{perl_vendorarch}/perlNPI.pm
/var/adm/perl-modules/openwbem
%{prefix}/%_lib/lib*.so*
%{prefix}/bin/*
%{prefix}/sbin/*
%{prefix}/share/openwbem/*
/var/adm/fillup-templates/sysconfig.owcimomd
%{_mandir}/man?/*
#%dir %_libdir/openwbem/cmpiproviders
#hack until OW is fixed to not care about empty dirs. 
%dir /opt/novell
%dir /opt/novell/lib
%dir /opt/novell/lib/openwbem
%dir /opt/novell/lib/openwbem/c++providers

%files devel
%defattr(-,root,root)
%dir %{prefix}/include/openwbem
%{prefix}/include/openwbem/*
%{prefix}/share/aclocal/openwbem.m4
%{prefix}/%_lib/lib*.a

%changelog -n openwbem
* Wed Nov 16 2005 - bwhiteley@suse.de
- New mof compiler fix to handle qualifiers in new namespaces
  New schema version
* Tue Nov 15 2005 - bwhiteley@suse.de
- updated to newer CVS and fixed init script for #65447
* Thu Oct 27 2005 - bwhiteley@suse.de
- Bring back stuff from the last 5 days that somehow was erased
  from existence.
- fixed rmmof.
- upgrade stuff.
* Thu Oct 20 2005 - bwhiteley@suse.de
- More work on upgrade issues
* Thu Oct 20 2005 - bwhiteley@suse.de
- trying to make gcc-4.1 and gcc-3.x _both_ happy ... at the same
  time
* Wed Oct 19 2005 - bwhiteley@suse.de
- Fixed friend injection stuff for new compiler in beta
- some adjustments to %%post for mls.
* Wed Oct 19 2005 - bwhiteley@suse.de
- new code from cvs with a new owmofc that automatically finds missing
  classes.  new loadmof.sh and .spec to match this change
- worked on upgrade issues, including repository format migration.
- includes repository dump for previos version (thus the old src tarball)
* Tue Oct 04 2005 - bwhiteley@suse.de
- Changed loadmof.sh to make it easier for providers to install.
- upgraded to cimv2.10-experimentsl, and added mofs as part of the
  package
* Mon Sep 19 2005 - bwhiteley@suse.de
- update to current CVS code.  This should fix the deprecation
  error with the latest compiler
* Thu May 19 2005 - bwhiteley@suse.de
- Updated to OpenWBEM CVS build to move toward code10
* Tue Apr 26 2005 - nashif@suse.de
- Create certificate when openwbem is first started instead of %%post
  (#62870)
- Fix minor syntax problem in openwbem.m4 (#62870)
* Thu Jan 27 2005 - bwhitele@suse.de
- Fixed %%post to enable local authentication on upgrade
  Bugzilla 50261
* Tue Jan 25 2005 - bwhitele@suse.de
- Fixed %%post to enable owcimomd
- Fixed PreReq to have all the stuff the scripts need.
* Wed Dec 08 2004 - bwhitele@suse.de
- Update to openwbem-3.1.0 official release.
- fixed mode of /etc/pam.d/openwbem
- changed %%post to not restart daemon on upgrade
* Tue Dec 07 2004 - bwhitele@suse.de
- Made local_auth true by default (Novell Remote Manager needs this).
* Mon Dec 06 2004 - bwhitele@suse.de
- Update to 3.1.0.pre3
* Tue Nov 23 2004 - bwhitele@suse.de
- Added a directory for novell providers so the CIMOM
  doesn't choke while trying to start.
* Mon Nov 22 2004 - bwhitele@suse.de
- Update to version 3.1.0.pre2
* Sat Oct 30 2004 - bwhiteley@suse.de
- Update to version 3.1.0.pre1
* Thu Oct 21 2004 - nashif@suse.de
- Update to version 3.0.3
* Tue Jul 20 2004 - nashif@suse.de
- Fixed problem in cmpiInstance.cpp. NULL value wasn't being
  checked when get the property from the instance. (#42826)
* Sat Jun 12 2004 - nashif@suse.de
- OpenWBEM CMPI :duration timestamp gets converted to datetime
  format (#41922)
* Thu Jun 10 2004 - nashif@suse.de
- Fixed bug #41763: OpenWBEM returns incorrect error codes from
  CMPI providers
* Tue Jun 01 2004 - nashif@suse.de
- Update to version 3.0.2 which fixes previous bugs (##41414)
  and fixes return value of daemon (#41440)
  V. 3.0.2
* Sun May 30 2004 - nashif@suse.de
- fixed to not crash when running sblim testsuite (#41414)
- Dont delete repository when updating
- Removed unneeded thread patch
* Thu May 13 2004 - nashif@suse.de
- added script rmmof script for sblim providers
- Load Interop schema
- Fixed init script to handle pid file correctly
* Thu Apr 29 2004 - nashif@suse.de
- Update to 3.0 final
* Sun Apr 18 2004 - nashif@suse.de
- Update to 3.0 pre4
* Fri Apr 16 2004 - nashif@suse.de
- Update to 3.0 pre3
- Modified loadmof.sh for new snapshot
* Tue Apr 06 2004 - nashif@suse.de
- Update to latest CVS branch (3.0.0pre2)
- Added loadmof to load cmpi providers
- Added Conflict to pegasus-wbem
- Provide cim-server
- cmpi provider path is now /usr/lib/cmpi
* Tue Feb 17 2004 - nashif@suse.de
- Update to latest CVS status
- Patches from novell (bwhiteley@novell.com):
- better defaults (more secure) for the config file
- schema gets compiled during RPM build, so the repository is
  loaded "out of the box" after RPM install.
- ACLs are enabled and a default ACL policy provided (root user
  can do anything,  nobody else can do anything).
* Sat Jan 10 2004 - adrian@suse.de
- build as user
* Wed Dec 10 2003 - nashif@suse.de
- fix build on s390
* Mon Dec 08 2003 - nashif@suse.de
- Update to latest cvs version
* Thu Nov 27 2003 - nashif@suse.de
- Initial Release
